# Home

POMDPSimulators is a collection of utilities for simulating [POMDPs.jl](https://github.com/JuliaPOMDP/POMDPs.jl) models. All of the simulators in this package should conform to the POMDPs.jl [Simulation Standard](http://juliapomdp.github.io/POMDPs.jl/latest/simulation/).

Examples can be found in the [simulation tutorial in the POMDPExamples package](https://github.com/JuliaPOMDP/POMDPExamples.jl/blob/master/notebooks/Running-Simulations.ipynb).

If you are just getting started, probably the easiest way to begin is the [`stepthrough` function](@ref Stepping-through). Otherwise, consult the [Which Simulator Should I Use?](@ref) page.

```@contents
Pages = ["index.md",
         "which.md",
         "rollout.md",
         "parallel.md",
         "history_recorder.md",
         "histories.md",
         "stepthrough.md",
         "display.md",
         "sim.md"]
```
